<?
/*
Plugin Name: WooCommerce i-Retail API
Description: i-Retail API для WooCommerce
Author: i-Retail.com
Author URI: http://i-retail.com/ 
Version: 0.1
*/

require (__DIR__.'/iretailapi.php');

if(!class_exists('WCIRetailAPI'))
{
  class WCIRetailAPI
  {
    public static function activate()
    {
    } 

    public static function deactivate()
    {
    }

    public static function init()
    {

    	add_action('admin_menu',  array('WCIRetailAPI', 'init_menu'),999);
    	add_action('admin_post_ir_clearlog',  array('WCIRetailAPI', 'admin_action_clear_log'));
			add_filter("plugin_action_links_".plugin_basename( __FILE__ ), array('WCIRetailAPI', 'add_settings_link'));    	

    	IRetailApi::config([
    		'debug'=>1,
    		'power'=>get_option('ir_power'),
    		'mode'=>get_option('ir_mode'),
    		'log'=>get_option('ir_log'),
    		'login'=>get_option('ir_login'),
    		'apikey'=>get_option('ir_apikey'),
    		'printmode'=>get_option('ir_printmode'),
    		'notifymode'=>get_option('ir_notifymode'),
    		'mailer'=>new WCIretailMailer(get_option('ir_emails')),
    	]);

    	if ((int)get_option('ir_power'))
    	{
        //add_action('woocommerce_order_status_processing', array('WCIRetailAPI', 'order_status_processing'), 10,1);
        add_action('woocommerce_pre_payment_complete', array('WCIRetailAPI', 'pre_payment_complete'), 10,1);
        add_action('woocommerce_payment_complete', array('WCIRetailAPI', 'payment_complete'), 10,1);
        //processing типа запрещенный статус для payment_complete поэтому другой ивент. см class-wc-order.php
        add_action('woocommerce_payment_complete_order_status_processing', array('WCIRetailAPI', 'payment_complete_order_status_processing'), 10,1);
        add_action('woocommerce_payment_complete_order_status_completed', array('WCIRetailAPI', 'payment_complete_order_status_completed'), 10,1);

        //для редактирования заказа
				add_action('woocommerce_order_actions', array('WCIRetailAPI', 'order_actions'), 10, 1 );
				add_action('woocommerce_order_action_iretail_payment', array('WCIRetailAPI','order_action_payment'),10,1 );
				add_action('woocommerce_order_action_iretail_refund', array('WCIRetailAPI','order_action_refund'),10,1 );

			}    
    } 

    public static function add_settings_link($links)
    {
	    $settings_link = '<a href="'.admin_url('admin.php?page=wciretail-settings').'">' . __( 'Settings' ) . '</a>';
  	  array_unshift( $links, $settings_link );
  		return $links;   	
    }

    public static function register_setting()
    {
	    register_setting('wciretailapi', 'ir_power');
	    register_setting('wciretailapi', 'ir_mode');
	    register_setting('wciretailapi', 'ir_login');
	    register_setting('wciretailapi', 'ir_apikey');
	    register_setting('wciretailapi', 'ir_log');
	    register_setting('wciretailapi', 'ir_printmode');
	    register_setting('wciretailapi', 'ir_notifymode');
	    register_setting('wciretailapi', 'ir_emails');
    }
    public static function init_menu()
    {
			//'woocommerce'
   		add_submenu_page('woocommerce', 'Настройка i-Retail API', 'i-Retail API', 'manage_options', 'wciretail-settings',
   				array('WCIRetailAPI', 'page_settings') );
   		add_action('admin_init', array('WCIRetailAPI', 'register_setting'));
    }
    public static function page_settings()
    {
// 			if (isset($_GET['af_debug']))
// 			{
// 				echo '<pre>';
// 				$order=wc_get_order(7780);
// 			// // 	echo 'ORDER ';print_r($order=wc_get_order(7780));
// 				$order_data=$order->get_data();
// 				// echo 'GET_DATA ';print_r($order->get_data());
// 			// // 	echo 'GET_ITEMS ';print_r($order->get_items());

// 	  //     foreach($order->get_items() as $item ) {
// 			// 		$product = wc_get_product($item['product_id']);
// 			// 		if ($item['total']!=0)
// 			// 		{
// 			//       $taxes=WC_Tax::get_rates($product->get_tax_class());
// 		 //      	var_dump($taxes);
// 			//     }
// 			//   }
// echo 'sl';
// 	      if (isset($order_data['shipping_lines']))
// 	      	foreach ($order_data['shipping_lines'] as $sl)
// 	      	{
// 	      		// var_dump($sl);
// 	      		foreach($sl->get_taxes()['total'] as $k=>$v)
// 	      			var_dump($k,WC_Tax::_get_tax_rate($k));
// 	      	}


// 				die;
// 			}

    	?>
			<div class="wrap">
        <h1>Настройки модуля i-Retail API для WooCommerce</h1>
				<form method="post" action="options.php">
          <?php
          // wp_nonce_field('update-options');
          settings_fields('wciretailapi');
          do_settings_sections('wciretailapi');
          ?>
						<table class="form-table">
            	<tr valign="top">
              	<th scope="row"><label for="ir_power">Модуль активен</label></th>
	              <td>
	  	            <label>
	  	            	<input type="hidden" name="ir_power" value="0"?>
	  	            	<input type="checkbox" name="ir_power" id="ir_power" value="1" <?php echo get_option('ir_power') == '1' ? 'checked="checked"' : ''; ?>/>
	  	            	Отправлять на фискализатор
	  	            </label>
	  	          </td>
	  	        </tr>
	  	        <tr>
              	<th scope="row"><label>Режим работы</label></th>
	              <td>
	  	            <label>
	  	            	<input type="radio" name="ir_mode" value="0" <?php echo get_option('ir_mode') == '0' ? 'checked="checked"' : ''; ?>/>
	  	            	Тестовый
	  	            </label>
	  	            &nbsp;&nbsp;&nbsp;&nbsp;
	  	            <label>
	  	            	<input type="radio" name="ir_mode" value="1" <?php echo get_option('ir_mode') == '1' ? 'checked="checked"' : ''; ?>/>
	  	            	Рабочий
	  	            </label>
  	          	</td>
              </tr>
            	<tr valign="top">
              	<th scope="row"><label for="ir_log">Включить журналирование</label></th>
	              <td>
	  	            <label>
	  	            	<input type="hidden" name="ir_log" value="0"?>
	  	            	<input type="checkbox" name="ir_log" id="ir_log" value="1" <?php echo get_option('ir_log') == '1' ? 'checked="checked"' : ''; ?>/>
	  	            </label>
	  	          </td>
	  	        </tr>              
            	<tr valign="top">
              	<th scope="row">Логин</th>
	              <td>
	 	            	<input type="text" name="ir_login" value="<?=esc_attr(get_option('ir_login'))?>"/>
		  	        </td>
	  	        </tr>              
            	<tr valign="top">
              	<th scope="row">API-ключ</th>
	              <td>
	 	            	<input type="text" name="ir_apikey" size="40" value="<?=esc_attr(get_option('ir_apikey'))?>"/>
		  	        </td>
	  	        </tr>
            	<tr valign="top">
              	<th scope="row">Режим печати/отправки</th>
	              <td>
                  <select name="ir_printmode" style="padding:2px;">
                    <? foreach (IRetailApi::$aPrintModes as $k=>$v) { ?>
                        <option value="<?=$k?>" <?=$k==get_option('ir_printmode')?'selected=\'selected\'':'';?>><?=$v?></option>
                    <? } ?>
                  </select>	  	        
		  	        </td>
	  	        </tr>
            	<tr valign="top">
              	<th scope="row">Режим уведомлений</th>
	              <td>
                  <select name="ir_notifymode" style="padding:2px;">
                    <? foreach (IRetailApi::$aNotifyModes as $k=>$v) { ?>
                        <option value="<?=$k?>" <?=$k==get_option('ir_notifymode')?'selected=\'selected\'':'';?>><?=$v?></option>
                    <? } ?>
                  </select>	  	        
		  	        </td>
	  	        </tr>
            	<tr valign="top">
              	<th scope="row">Email(ы) для уведомлений (через запятую)</th>
	              <td>
	 	            	<input type="text" name="ir_emails" size="40" value="<?=esc_attr(get_option('ir_emails'))?>"/>
		  	        </td>
	  	        </tr>	  	        
            </table>

        	<?php submit_button(); ?>
        
				</form>

				<form action="<?php echo admin_url( 'admin-post.php' ); ?>" method="post">
					<?wp_referer_field();?>
					<input type="hidden" name="action" value="ir_clearlog">
					<h2>Журнал работы i-Retail API &nbsp;&nbsp;&nbsp;&nbsp;<?php submit_button( 'Очистить журнал','delete',false,false ); ?></h2>
				</form>					
				<div class="card" style="max-width:80%;max-height:500px;overflow:auto;white-space: pre-wrap;"><?
					$l=IRetailAPI::getLog();
					if (trim($l))
						echo (esc_html($l));
					else
						echo 'Журнал пуст';
				?></div>
			</div>
			<?
    }


		public static function admin_action_clear_log()
		{
			IRetailAPI::clearLog();
      wp_safe_redirect( urldecode( $_POST['_wp_http_referer'] ) );
      exit;				
		}


		/////////// редактирование заказа
		public static function order_actions($actions)
		{
			if ( is_array( $actions ) ) {
				$actions['iretail_payment'] = __( 'Отправить платеж на i-Retail.com' );
				$actions['iretail_refund'] = __( 'Отправить возврат на i-Retail.com' );
			}
			return $actions;
		}
		public static function order_action_payment($order)
		{
			self::order2iretail($order->get_id());
		}
		public static function order_action_refund($order)
		{
			self::order2iretail($order->get_id(),true);
		}

		///////////////////////////
		//ивенты заказа

    public static function pre_payment_complete($order_id)
    {
    	$order = wc_get_order( (int)$order_id );
    	IRetailAPI::debug("action pre_payment_complete ".$order_id." status=".($order?$order->get_status():"???"));
    }

    public static function payment_complete($order_id)
    {
    	IRetailAPI::debug("action payment_complete ".$order_id);
    	self::order2iretail($order_id);
    }

    public static function payment_complete_order_status_processing($order_id)
    {
    	IRetailAPI::debug("action payment_complete_order_status_processing ".$order_id);
    	self::order2iretail($order_id);
    }
    public static function payment_complete_order_status_completed($order_id)
    {
    	IRetailAPI::debug("action payment_complete_order_status_completed ".$order_id);
    	self::order2iretail($order_id);
    }

    //////////////////////////////////////////

    public static function order2iretail($order_id,$refund=false)
    {
      if ((int)$order_id)
      {

				$order = wc_get_order( (int)$order_id );
				$order_data = $order->get_data();
				
				// IRetailAPI::debug('order_data '.print_r($order_data,1));

		    $data = [
	        'external_order_id' => $order_data['id'],
	        'external_order_time' => gmdate('Y-m-d H:i:s',$order_data['date_created']->getTimestamp()), //$order_data['date_created']->date('Y-m-d H:i:s'),
	        'date_time' => gmdate('Y-m-d H:i:s',$order_data['date_created']->getTimestamp()),
	        // 'mode' => 'print_email', по настройке
	        'type' => $refund?'refund':'payment',
	        'customer_phone' => $order_data['billing']['phone'],
	        'customer_email' => $order_data['billing']['email'],
	        'card_amount' => $order_data['total'],
	        // 'cash_amount' => 0,
	        // 'mc_amount' => 0,
	        'purchase' => ['products' => []],
	      ];

				$order_items = array();
				foreach( $order-> get_items() as $item_key => $item_values )
					$order_items[]=$item_values->get_data();

	      foreach($order_items as $item ) {
					if ($item['total']!=0)
					{
		      	$d=[
		      		'name'=>$item['name'],
		      		'quantity'=>$item['quantity'],
		      		// 'price'=>$item['total']/max(1,$item['quantity']),
			      ];

						$product = wc_get_product($item['product_id']);
						$d['price']=number_format(($item['total']+$item['total_tax'])/$item['quantity'],2,".","");
						// $d['price']=wc_get_price_including_tax($product);
						// $vat=($d['price']/$product->get_price())-1;
						 // var_dump($item);die;
						// if ($vat)
						// 	$d['vat']=number_format($vat,2,".","");
			   //    $taxes=WC_Tax::get_rates($product->get_tax_class());
			   //    var_dump($taxes);die;
						if (isset($item['total']) && isset($item['total_tax']) && $item['total_tax']!=0)
							$d['vat']=number_format(floatval($item['total_tax'])/floatval($item['total']),2,".","");
			      // if ($taxes)
			      // {
			      // 	$taxes=reset($taxes);
			      // 	$rate=floatval($taxes['rate'])/100;
			      // 	if ($rate!=0)
			      // 		$d['vat']=number_format($rate,2,".","");
			      // }
		      	$data['purchase']['products'][]=$d;
			    }
	      }

	      // if (isset($order_data['tax_lines']))
	      // 	foreach ($order_data['tax_lines'] as $sl)
	      // 		if ($sl->get_tax_total()!=0)
		     //  	{
			    //   	$data['purchase']['products'][]=[
			    //   		'name'=>$sl->get_name(),
			    //   		'price'=>$sl->get_tax_total()+$sl->get_shipping_tax_total(),
			    //   		'quantity'=>1,
				   //    ];
				   //  }	      

	      if (isset($order_data['shipping_lines']))
	      	foreach ($order_data['shipping_lines'] as $sl)
	      		if ($sl->get_total()!=0)
		      	{
			      	$d=[
			      		'name'=>$sl->get_name(),
			      		'price'=>$sl->get_total()+$sl->get_total_tax(),
			      		'quantity'=>1,
				      ];
				      $t=$sl->get_taxes();
				      $t=$t['total'];
	      			$taxes=WC_Tax::_get_tax_rate(key($t));
	      			// var_dump($taxes);
							$rate=floatval($taxes['tax_rate'])/100;
	      			// var_dump($rate);
	      			// die;
			      	if ($rate!=0)
			      		$d['vat']=number_format($rate,2,".","");	      			
// $rate=floatval($taxes['rate'])/100;
// 			      	if ($rate!=0)
// 			      		$d['vat']=number_format($rate,2,".");

// 				      		      		_get_tax_rate
			      	$data['purchase']['products'][]=$d;
				    }

				$ret=IRetailAPI::request($data);
	    	$order->add_order_note($ret['text']);
		  }
    }

  }

  class WCIretailMailer implements IretailMailerInterface {
  	use IretailMailerTrait;

  	function notify($subject, $message)
  	{
  		foreach ($this->emails as $e)
  			wp_mail($e,$subject, $message);
  	}

  }
}

register_activation_hook(__FILE__, array('WCIRetailAPI', 'activate'));
register_deactivation_hook(__FILE__, array('WCIRetailAPI', 'deactivate'));
WCIRetailAPI::init();
